//--------------------------------------------------------------------
//- OpenGL - Partikel Systeme
//- Tutorial 3 - Blitze
//--
//- @author Tobias Rick
//- @version 1.0
//- @date: 04.04.02
//--------------------------------------------------------------------

#include "main.h"

#include "partemitter.h"

#include "bolt.h"

bool  g_bFullScreen = true;						
HWND  g_hWnd;											
RECT  g_rRect;										
HDC   g_hDC;											
HGLRC g_hRC;											
HINSTANCE g_hInstance;						

GLuint	g_Texture[MAX_TEXTURES];		// Speicher fr Texturen
CTimer g_Timer;
CPartEmitter* g_pEmitter = NULL;
CPartEmitter* g_pEmitter2 = NULL;
float g_fLastUpdate = 0;
float g_fLastUpdate2 = 0;

float g_vPos[3] = {0,0,-240};	// Cameraposition

float g_clrColor[4] = {0.2f,0.2f,0.2f,1.0f};

float g_fColVal = 0.2f;
float g_fColChange = 0.0f;

void BuildParticles(bool b);

void InitParticles()
{
	// neues Emitterobjekt das bis zu 500 Partikel verwalten kann
	g_pEmitter = new CPartEmitter(500);
	// neues Emitterobjekt das bis zu 300 Partikel verwalten kann
	g_pEmitter2 = new CPartEmitter(300);
	
	g_Timer.Init();

	g_Timer.Update();
	CPartEmitter::m_fCurTime = g_Timer.GetCurrentTime();
	CPartEmitter::m_fFrameTime = g_Timer.GetFrameTime();

	// Partikel zum Emitter hinzufgen
	BuildParticles(true);
}

void BuildParticles(bool b)
{
	// falls b true, wird neuer Partikel zu Emitter1 hinzugefgt,
	// ansonsten zu Emitter2
	if(b)
	{
		// *NEU* 
		CBolt* p = new CBolt(g_pEmitter);
		VECTOR vPos = {2*((rand() % 400)-200),	50,		-550 -(2*(rand() % 500))};
		VECTOR vVel= {0,0,0};
		float clrCol[4] = { 1,1,1,1};
		float clrChangeCol[4] = {0,0,0,0};
		float fFade = 4.0f; 
		float fLife = 0.2f;
		float fSize = 220.0f + ( (rand() % 10)  -5)*0.1;
		float fChangeSize = 0;
		p->m_fFadeInSpeed = 10.0f;
		p->Set(vPos,vVel,clrCol,clrChangeCol,fSize,fChangeSize,fLife,fFade);
		p->m_pColChange = &g_fColChange;	// *NEU* 
		g_pEmitter->Add(p);

	}else
	{
		CBolt* p = new CBolt(g_pEmitter2);// *NEU* 
		
		VECTOR vPos = {2*((rand() % 200)-100),50,-550-((rand() % 200)*2)};
		VECTOR vVel= {0,0,0};
		float clrCol[4] = { 1,1,1,1};
		float clrChangeCol[4] = {0,0,0,0};
		float fFade = 4.0f;//10.0f; 
		float fLife = 0.2f;
		float fSize = 220.0f + ( (rand() % 10)  -5)*0.1;
		float fChangeSize = 0;
		p->m_fFadeInSpeed = 10.0f;
		p->Set(vPos,vVel,clrCol,clrChangeCol,fSize,fChangeSize,fLife,fFade);

		p->m_pColChange = &g_fColChange;// *NEU* 

		g_pEmitter2->Add(p);
	}
}



void Init(HWND hWnd)
{
	srand( (unsigned)time( NULL ) );	// Zufallszahlen generieren

	g_hWnd = hWnd;										
	GetClientRect(g_hWnd, &g_rRect);	
	
	InitOpenGL(g_rRect.right, g_rRect.bottom);	

	LoadGLTextures();	// Texturen laden

	InitParticles();	// Partikelsystem initialisieren

	// OpenGL Einstellungen
	glShadeModel(GL_SMOOTH);							
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);	
	glHint(GL_POINT_SMOOTH_HINT,GL_NICEST);				
	glClearDepth(1.0f);									
	glDisable(GL_DEPTH_TEST);							
	glClearColor(0.0f,0.0f,0.0f,1.0f);		// Schwarzer Hintergrund
		
	// Blending Einstellungen
	glEnable(GL_BLEND);									
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);		
	
	glEnable(GL_TEXTURE_2D);							

	glBindTexture(GL_TEXTURE_2D,g_Texture[0]);	// Schneetextur auswhlen
}



void KeyPressed()
{
	// keine Benutzereingaben mglich	
	
}

WPARAM MainLoop()
{
	MSG msg;

	while(1)											
	{													
		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) 
        { 
			if(msg.message == WM_QUIT)					
				break;
            TranslateMessage(&msg);						
            DispatchMessage(&msg);						
        }
		else											
		{ 
			// Hauptschleife
			g_Timer.Update();
			CPartEmitter::m_fCurTime = g_Timer.GetCurrentTime();
			CPartEmitter::m_fFrameTime = g_Timer.GetFrameTime();

			KeyPressed();
			RenderScene();							
     } 
	}

	// Speicher freigeben
	Shutdown();				
	if (g_pEmitter)
	{
		delete g_pEmitter;
		g_pEmitter = NULL;
	}

	if (g_pEmitter2)
	{
		delete g_pEmitter2;
		g_pEmitter2 = NULL;
	}


	return(msg.wParam);									
}

void DrawBackground()
{
	
	glDisable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, g_Texture[1]);

	// *NEU* 
	glColor4f(g_fColVal+g_fColChange,g_fColVal+g_fColChange,g_fColVal+g_fColChange,1.0f);
	
	
	glBegin(GL_QUADS);
		glTexCoord2i(0,3);
		glVertex3f(-300,-15.5,-300);
		glTexCoord2i(3,3); 
		glVertex3f(300,-15.5,-300);
		glTexCoord2i(3,0); 
		glVertex3f(300,-15.5,500);
		glTexCoord2i(0,0); 
		glVertex3f(-300,-15.5,500);
	glEnd();

	glBindTexture(GL_TEXTURE_2D, g_Texture[2]);
	
	// Texture-Bewegung
	static float t =0.0f;
	t += g_Timer.GetFrameTime()*0.07;


	glBegin(GL_QUADS);
		glTexCoord2f(0-t,3);
		glVertex3f(-300,100,-300);
		glTexCoord2f(3-t,3); 
		glVertex3f(300,100,-300);
		glTexCoord2f(3-t,0); 
		glVertex3f(300,100,500);
		glTexCoord2f(0-t,0); 
		glVertex3f(-300,100,500);
	glEnd();

	glBegin(GL_QUADS);
		glTexCoord2f(0-t,1);
		glVertex3f(-300,-15.5,-300);
		glTexCoord2f(3-t,1); 
		glVertex3f(300,-15.5,-300);
		glTexCoord2f(3-t,0); 
		glVertex3f(300,100,-300);
		glTexCoord2f(0-t,0); 
		glVertex3f(-300,100,-300);
	glEnd();

	glBegin(GL_QUADS);
		glTexCoord2i(0,1);
		glVertex3f(-300,-15.5,500);
		glTexCoord2i(3,1); 
		glVertex3f(300,-15.5,500);
		glTexCoord2i(3,0); 
		glVertex3f(300,100,500);
		glTexCoord2i(0,0); 
		glVertex3f(-300,100,500);
	glEnd();

	glBegin(GL_QUADS);
		glTexCoord2i(0,1);
		glVertex3f(300,-15.5,-300);
		glTexCoord2i(3,1); 
		glVertex3f(300,-15.5,500);
		glTexCoord2i(3,0); 
		glVertex3f(300,100,500);
		glTexCoord2i(0,0); 
		glVertex3f(300,100,-300);
	glEnd();
	glBegin(GL_QUADS);
		glTexCoord2i(0,1);
		glVertex3f(-300,-15.5,-300);
		glTexCoord2i(3,1); 
		glVertex3f(-300,-15.5,500);
		glTexCoord2i(3,0); 
		glVertex3f(-300,100,500);
		glTexCoord2i(0,0); 
		glVertex3f(-300,100,-300);
	glEnd();
	

	
	glEnable(GL_BLEND);
}

void RenderScene() 
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	
	glLoadIdentity();									

	glTranslatef(g_vPos[0],g_vPos[1],g_vPos[2]);
		
	DrawBackground();	// Hintergrund zeichnen
	g_fColChange = 0.0f;
	if(g_Timer.GetCurrentTime() - g_fLastUpdate  > 1.6f +((( rand() %6)-3 )*0.1))
	{
		BuildParticles(true);	// Neue Partikel fr Emitter 1
		g_fLastUpdate = g_Timer.GetCurrentTime();
	}
	
	if(g_Timer.GetCurrentTime() - g_fLastUpdate2  >2.6f+((( rand() %6)-3 )*0.1))
	{
		BuildParticles(false);// Neue Partikel fr Emitter 2
		g_fLastUpdate2 = g_Timer.GetCurrentTime();
	}

	// Emitter 1 hat Textur 0
	glBindTexture(GL_TEXTURE_2D, g_Texture[0]);
	g_pEmitter->Update();	// Partikel zeichnen

	// Emitter 2 hat Textur 3
	glBindTexture(GL_TEXTURE_2D, g_Texture[3]);
	g_pEmitter2->Update();	// Partikel zeichnen

	SwapBuffers(g_hDC);									
}


LRESULT CALLBACK WinProc(HWND hWnd,UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LONG    lRet = 0; 
	PAINTSTRUCT    ps;
  
	switch (uMsg)
	{ 
		case WM_SYSCOMMAND:          
			{
				if(wParam== SC_SCREENSAVE)       // Bildschirmschoner deaktivieren
					return false; 
				else
					lRet = DefWindowProc (hWnd, uMsg, wParam, lParam); 
			 
			}			break; 

    case WM_SIZE:										
		if(!g_bFullScreen)								
		{
			ReSize(LOWORD(lParam),HIWORD(lParam));
			GetClientRect(hWnd, &g_rRect);				
		}
        break; 
 
	case WM_PAINT:										
		BeginPaint(hWnd, &ps);					
		EndPaint(hWnd, &ps);						
		break;


	case WM_KEYDOWN:									
		switch (wParam)									
		{
			case VK_ESCAPE:								
				PostQuitMessage(0);					
				break;
		}
		break;

    case WM_CLOSE:										
        PostQuitMessage(0);						
        break; 
     
    default:											
        lRet = DefWindowProc (hWnd, uMsg, wParam, lParam); 
        break; 
    } 
 
    return lRet;									
}
